"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
const MotionType_1 = __importDefault(require("../../enums/MotionType"));
const Box_1 = __importDefault(require("../../objects/Box"));
function FocuserQuest2(Base) {
    class FocuserQuest2MixIn extends Base {
        defaults() {
            return Object.assign(Object.assign({}, super.defaults()), { focusRaycaster: new three_1.Raycaster() });
        }
        init() {
            super.init();
            this.dummy = new Box_1.default({
                width: 0.1,
                height: 0.1,
                depth: 0.1,
                mass: 0,
                material: new three_1.MeshLambertMaterial({
                    color: 0x00ff00,
                }),
            });
            this.project.scene.addMass(this.dummy, MotionType_1.default.Kinematic);
        }
        update(p) {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
            super.update(p);
            const ply = this.project.player;
            const pp = ply.leftHand._hand.getWorldPosition(new three_1.Vector3());
            const pd = ply.leftHand.getWorldDirection(new three_1.Vector3()).multiplyScalar(-1);
            this.dummy.position.set(pp.x, pp.y, pp.z);
            this.focusRaycaster.set(pp, pd);
            const targets = this.focusTargets.map(m => m);
            const intersects = this.focusRaycaster.intersectObjects(targets);
            const hitTargetIdx = intersects.length > 0 ? targets.indexOf(intersects[0].object) : -1;
            if (hitTargetIdx >= 0)
                this.focusTargets[hitTargetIdx].focus();
            this.focusTargets.forEach((target, idx) => {
                if (idx !== hitTargetIdx && target.isFocused)
                    target.blur();
            });
            if (!!(p === null || p === void 0 ? void 0 : p.frame) && ply.leftHand) {
                ply.leftHand.targetRayPose = p.frame.getPose((_a = this.left) === null || _a === void 0 ? void 0 : _a.targetRaySpace, this.refSpace);
                ply.leftHand.triggerTouched = !!((_e = (_d = (_c = (_b = this.left) === null || _b === void 0 ? void 0 : _b.gamepad) === null || _c === void 0 ? void 0 : _c.buttons) === null || _d === void 0 ? void 0 : _d[0]) === null || _e === void 0 ? void 0 : _e.touched);
            }
            if (!!(p === null || p === void 0 ? void 0 : p.frame) && ply.rightHand) {
                ply.rightHand.targetRayPose = p.frame.getPose((_f = this.right) === null || _f === void 0 ? void 0 : _f.targetRaySpace, this.refSpace);
                ply.rightHand.triggerTouched = !!((_k = (_j = (_h = (_g = this.right) === null || _g === void 0 ? void 0 : _g.gamepad) === null || _h === void 0 ? void 0 : _h.buttons) === null || _j === void 0 ? void 0 : _j[0]) === null || _k === void 0 ? void 0 : _k.touched);
            }
        }
    }
    return FocuserQuest2MixIn;
}
exports.default = FocuserQuest2;
//# sourceMappingURL=FocuserQuest2.js.map