"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
function Selectable(Base) {
    class SelectableMixIn extends Base {
        defaults() {
            return Object.assign(Object.assign({}, super.defaults()), { isSelectable: true, selectMaterial: new three_1.MeshLambertMaterial({
                    transparent: true,
                    opacity: 0.4,
                    userData: { importance: 1 },
                }) });
        }
        init() {
            super.init();
            this.selectMaterial.color = this.material.color;
            const wireframe = new three_1.WireframeGeometry(this.geometry);
            this.lines = new three_1.LineSegments(wireframe);
            this.lines.material = new three_1.LineBasicMaterial({ color: this.material.color });
        }
        select() {
            if (this.isSelected)
                return;
            this.isSelected = true;
            this.setMaterial(this.selectMaterial);
            this.add(this.lines);
            this.onChangeSelected(true);
        }
        deselect() {
            if (!this.isSelected)
                return;
            this.isSelected = false;
            this.removeMaterial(this.selectMaterial);
            this.remove(this.lines);
            this.onChangeSelected(false);
        }
        onChangeSelected(v) { }
    }
    return SelectableMixIn;
}
exports.default = Selectable;
//# sourceMappingURL=Selectable.js.map