import ConstructorOf from '@thats/utils/types/ConstructorOf';
import XRController, { XRControllerConstructor } from '../../core/XRController';
import { IFocuser } from '../focuser/Focuser';
import { ISelectable } from './Selectable';
export interface ISelector extends XRController {
    selected: ISelectable[];
    selectorTargets: ISelectable[];
    select(v: ISelectable): void;
    deselect(v: ISelectable): void;
    deselectAll(): void;
    onChangeSelected(v: ISelectable[]): void;
}
export default function Selector(): ((<T extends XRController>(Base: XRControllerConstructor<T>) => ConstructorOf<T & IFocuser>) | typeof SelectorMixIn)[];
declare function SelectorMixIn<T extends IFocuser>(Base: XRControllerConstructor<T>): ConstructorOf<T & ISelector>;
export {};
