import ConstructorOf from '@thats/utils/types/ConstructorOf';
import { XRSession } from 'three';
import GrabActionType from '../enums/GrabActionType';
import PlayState from '../enums/PlayState';
import XRParam from './XRParam';
import XRPlayer from './XRPlayer';
import XRScene from './XRScene';
import XRViewer from './XRViewer';
export interface XRProjectState {
    play: PlayState;
    grabAction: GrabActionType;
    godMode: boolean;
}
declare const XRProject_base: ConstructorOf<import("./XRClass").IClass>;
export default class XRProject extends XRProject_base {
    private _state;
    private Scene;
    private clock;
    scene: XRScene;
    session: XRSession;
    player: XRPlayer;
    viewer: XRViewer;
    get state(): XRProjectState;
    setPlayState(v: PlayState): void;
    setGrabActionState(v: GrabActionType): void;
    setGodModeState(v: boolean): void;
    setScene(S: ConstructorOf<XRScene>): void;
    defaults(): any;
    init(): void;
    initViewer(el: HTMLElement, dims: any): void;
    setParam<T>(param: XRParam<T>, value: T): void;
    start(): void;
    stop(): void;
    pause(): void;
    play(): void;
    startXR(): void;
    _endXR: any;
    endXR(): void;
    destroy(): void;
    private tick;
    private untick;
    private _tock;
    private tock;
}
export {};
