"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.computeScale = void 0;
const three_1 = require("three");
const ShapeFit_1 = __importDefault(require("../enums/ShapeFit"));
exports.computeScale = (function () {
    const matrix = new three_1.Matrix4();
    return function (matrixWorld, options = {}) {
        const scale = new three_1.Vector3(1, 1, 1);
        if (options.fit === ShapeFit_1.default.ALL) {
            matrix.fromArray(matrixWorld);
            scale.setFromMatrixScale(matrix);
        }
        return scale;
    };
})();
exports.default = exports.computeScale;
//# sourceMappingURL=computeScale.js.map